// DisplayBitmapsView.cpp : implementation of the CDisplayBitmapsView class
//

#include "stdafx.h"
#include "DisplayBitmaps.h"

#include "DisplayBitmapsDoc.h"
#include "DisplayBitmapsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CDisplayBitmapsView

IMPLEMENT_DYNCREATE(CDisplayBitmapsView, CView)

BEGIN_MESSAGE_MAP(CDisplayBitmapsView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CDisplayBitmapsView construction/destruction

CDisplayBitmapsView::CDisplayBitmapsView()
{
  static int nBits[] = {1, 4, 8, 16, 24, 32};
  for (int i = 0; i < 6; i++)
  {
    m_Bitmaps[i].CreateBitmap(54, 64, 1, nBits[i], NULL);
  }
  m_Bitmaps[6].LoadBitmap(IDB_BITMAP1);
}

CDisplayBitmapsView::~CDisplayBitmapsView()
{
}

BOOL CDisplayBitmapsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CDisplayBitmapsView drawing

void CDisplayBitmapsView::OnDraw(CDC* pDC)
{
	CDisplayBitmapsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

  CString strBits;

  BITMAP* pBitmapInfo = new BITMAP;
  pDC->TextOut(100, 5, "Number of bits per bitmap");
  for (int i = 0; i < 7; i++)
  {
    CDC MemDC;
    CBitmap *pOldBitmap;
    MemDC.CreateCompatibleDC(pDC);
    pOldBitmap = MemDC.SelectObject(&m_Bitmaps[i]);

    int iSuccess = m_Bitmaps[i].GetBitmap(pBitmapInfo);
    ASSERT(iSuccess);
    if (iSuccess)
    {
      strBits.Format("%ld", pBitmapInfo->bmBitsPixel);
      pDC->TextOut((20 + i * 50) + (pBitmapInfo->bmWidth / 2), 20, strBits);

      pDC->BitBlt(20 + i * 50, 50, 
                  54, 64, 
                  &MemDC,
                  0, 0, 
                  SRCCOPY);
      MemDC.SelectObject(pOldBitmap);
    }
  }
  delete pBitmapInfo;
}

// CDisplayBitmapsView printing

BOOL CDisplayBitmapsView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDisplayBitmapsView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDisplayBitmapsView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CDisplayBitmapsView diagnostics

#ifdef _DEBUG
void CDisplayBitmapsView::AssertValid() const
{
	CView::AssertValid();
}

void CDisplayBitmapsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDisplayBitmapsDoc* CDisplayBitmapsView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDisplayBitmapsDoc)));
	return (CDisplayBitmapsDoc*)m_pDocument;
}
#endif //_DEBUG


// CDisplayBitmapsView message handlers
