// ShowDIBView.cpp : implementation of the CShowDIBView class
//

#include "stdafx.h"
#include "ShowDIB.h"

#include "ShowDIBDoc.h"
#include "ShowDIBView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShowDIBView

IMPLEMENT_DYNCREATE(CShowDIBView, CView)

BEGIN_MESSAGE_MAP(CShowDIBView, CView)
	//{{AFX_MSG_MAP(CShowDIBView)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShowDIBView construction/destruction

CShowDIBView::CShowDIBView()
{
}

CShowDIBView::~CShowDIBView()
{
}

BOOL CShowDIBView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CShowDIBView drawing

void CShowDIBView::OnDraw(CDC* pDC)
{
	CShowDIBDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	RECT Rect;
	GetClientRect( &Rect );
	m_Dib.SetPalette( pDC );
	m_Dib.Draw( pDC, 0, 0,
		Rect.right, Rect.bottom );

}

/////////////////////////////////////////////////////////////////////////////
// CShowDIBView diagnostics

#ifdef _DEBUG
void CShowDIBView::AssertValid() const
{
	CView::AssertValid();
}

void CShowDIBView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CShowDIBDoc* CShowDIBView::GetDocument()
	// non-debug version is inline
{
	ASSERT(
		m_pDocument->IsKindOf(RUNTIME_CLASS(CShowDIBDoc)));
	return (CShowDIBDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CShowDIBView message handlers

void CShowDIBView::OnFileOpen() 
{
	static char szFilter[] = "BMP Files(*.BMP)|*.BMP||";

	CFileDialog FileDlg( TRUE, NULL, NULL,
		OFN_HIDEREADONLY, szFilter );

	if( FileDlg.DoModal() == IDOK &&
		m_Dib.Load( FileDlg.GetPathName() ) ){
		InvalidateRect( NULL, TRUE );
		UpdateWindow();
		}

}
